summaryrefslogtreecommitdiff
path: root/sh
diff options
context:
space:
mode:
authorWilliam Hubbs <w.d.hubbs@gmail.com>2015-05-09 16:22:37 -0500
committerWilliam Hubbs <w.d.hubbs@gmail.com>2015-10-29 09:31:32 -0500
commit1133e238cb69f5700878f92183e0b43d5a3624ff (patch)
tree55679ead63bddd7517aa98e48dc27c302bab9f65 /sh
parentee944553a9ea35622046bd1ab5657fd416a7019a (diff)
Add support for runitgithub/runit
Diffstat (limited to 'sh')
-rw-r--r--sh/Makefile3
-rw-r--r--sh/openrc-run.sh.in4
-rw-r--r--sh/runit.sh30
3 files changed, 36 insertions, 1 deletions
diff --git a/sh/Makefile b/sh/Makefile
index b9b9fb33..9767ad93 100644
--- a/sh/Makefile
+++ b/sh/Makefile
@@ -1,7 +1,8 @@
DIR= ${LIBEXECDIR}/sh
SRCS= init.sh.in functions.sh.in gendepends.sh.in \
openrc-run.sh.in rc-functions.sh.in tmpfiles.sh.in ${SRCS-${OS}}
-INC= rc-mount.sh functions.sh rc-functions.sh s6.sh start-stop-daemon.sh
+INC= rc-mount.sh functions.sh rc-functions.sh runit.sh s6.sh \
+ start-stop-daemon.sh
BIN= gendepends.sh init.sh openrc-run.sh tmpfiles.sh ${BIN-${OS}}
INSTALLAFTER= _installafter
diff --git a/sh/openrc-run.sh.in b/sh/openrc-run.sh.in
index 8aba4e0e..5854231e 100644
--- a/sh/openrc-run.sh.in
+++ b/sh/openrc-run.sh.in
@@ -132,6 +132,7 @@ start()
{
local func=ssd_start
case "$supervisor" in
+ runit) func=runit_start ;;
s6) func=s6_start ;;
?*)
ewarn "Invalid supervisor, \"$supervisor\", using start-stop-daemon"
@@ -144,6 +145,7 @@ stop()
{
local func=ssd_stop
case "$supervisor" in
+ runit) func=runit_stop ;;
s6) func=s6_stop ;;
?*)
ewarn "Invalid supervisor, \"$supervisor\", using start-stop-daemon"
@@ -156,6 +158,7 @@ status()
{
local func=ssd_status
case "$supervisor" in
+ runit) func=runit_status ;;
s6) func=s6_status ;;
?*)
ewarn "Invalid supervisor, \"$supervisor\", using start-stop-daemon"
@@ -186,6 +189,7 @@ unset _conf_d
sourcex -e "@SYSCONFDIR@/rc.conf"
# load service supervisor functions
+sourcex "@LIBEXECDIR@/sh/runit.sh"
sourcex "@LIBEXECDIR@/sh/s6.sh"
sourcex "@LIBEXECDIR@/sh/start-stop-daemon.sh"
diff --git a/sh/runit.sh b/sh/runit.sh
new file mode 100644
index 00000000..ae4ad776
--- /dev/null
+++ b/sh/runit.sh
@@ -0,0 +1,30 @@
+# Copyright (c) 2014 Benda Xu <heroxbd@gentoo.org>
+# Released under the 2-clause BSD license.
+
+runit_start()
+{
+ local service_dir runit_service
+ service_dir="${runit_service_dir:-/etc/sv}
+ runit_service="${service_dir}/${RC_SVCNAME}"
+ if [ ! -d "${runit_service}" ]; then
+ eerror "Runit service ${runit_service} not found"
+ return 1
+ fi
+ ebegin "Starting ${name:-$RC_SVCNAME}"
+ ln -snf "${runit_service}" "${RC_SVCDIR}/runit/$RC_SVCNAME" &&
+ sv check up "${RC_SVCDIR}/runit/$RC_SVCNAME"
+ eend $? "Failed to start $RC_SVCNAME"
+}
+
+runit_stop()
+{
+ ebegin "Stopping ${name:-$RC_SVCNAME}"
+ sv down "${RC_SVCDIR}/runit/${RC_SVCNAME}" &&
+ rm "${RC_SVCDIR}/runit/${RC_SVCNAME}"
+ eend $? "Failed to stop $RC_SVCNAME"
+}
+
+runit_status()
+{
+ sv status "${RC_SVCDIR}/runit/${RC_SVCNAME}"
+}